----------------------------------------------------------------------
-- Fsadc.vhd
-- Description:   
-- Author:        Carsten Wulff <wulff@iet.ntnu.no>
-- Created at:    Thu Sep 14 12:16:00 2006
-- Modified at:   Thu Jan 31 11:19:41 2008
-- Modified by:   Carsten Wulff <wulff@iet.ntnu.no>
----------------------------------------------------------------------
-- Sub ADC
-- This converts the input into the 1.5 bits (00,01,10) output (b0 b1).
-- The bit values are converted into a thermometer code in t0 t1 t2 which
-- can be used to control switches 
library IEEE;
use IEEE.math_real.all;
use IEEE.electrical_systems.all; 
USE IEEE.STD_LOGIC_1164.ALL;
entity SADC is
  port (
    terminal vin,vip,vcm,vrn,vrp: Electrical;
    signal phi1a : in std_logic;
    signal b : out std_ulogic_vector(0 to 1);
    signal t : out std_ulogic_vector(0 to 2));
end SADC;

architecture ideal of SADC is
quantity svin across vin;
quantity svip across vip;
quantity svcm across vcm;
quantity svrn across vrn;
quantity svrp across vrp;
signal b0,b1 : std_logic;
begin 

p1: process(phi1a)
  variable vrhi,vrlo,vi,vswing : real;
begin

  if phi1a'event and phi1a = '0' then
        vi := svip - svin;
        vswing := svrp - svrn;
        if(vi > vswing/4.0) then
          b <= "10";
          t <= "100";
        elsif ((vi <= vswing/4.0) and (vi > -vswing/4.0)) then
          b <= "01";
          t <= "010";
        else
          b <= "00";
          t <= "001";
        end if;
  end if;    
end process p1;
end ideal;
