library ieee;
use ieee.std_logic_1164.all;
-- From http://toolbox.xilinx.com/docsan/3_1i/data/fise/xst/chap02/xst02007.htm
-- Dual edge triggered shift register. Used to synchronize the bits from SADCs
entity shift is
  port(C, SI : in  std_logic;
        T: out std_logic_vector(9 downto 0));
end shift;
architecture archi of shift is
  signal tmp: std_logic_vector(9 downto 0);
begin
  T <= tmp;
  reg: process (C)
  begin
    if (C'event and (C='0' or C='1')) then
      tmp(9 downto 1) <= tmp(8 downto 0);
      tmp(0) <= SI;
    end if;
  end process;

end archi;



