----------------------------------------------------------------------
-- Foutputrecord.vhd
-- Description:   
-- Author:        Carsten Wulff <wulff@iet.ntnu.no>
-- Created at:    Mon Sep 25 13:55:25 2006
-- Modified at:   Tue Jan  8 12:25:54 2008
-- Modified by:   Carsten Wulff <wulff@iet.ntnu.no>
----------------------------------------------------------------------
library IEEE;
use IEEE.math_real.all;
use IEEE.electrical_systems.all;
use IEEE.STD_LOGIC_1164.all;
use IEEE.STD_LOGIC_ARITH.all;
use IEEE.STD_LOGIC_UNSIGNED.all;
use STD.TEXTIO.all;
use IEEE.std_logic_textio.all;
entity OutputRecord is
  port(
    clk          : in  std_logic;
    ctrlin       : in  std_logic;
    output       : in  std_logic_vector (0 to 11)

    );
end entity OutputRecord;

architecture struct of OutputRecord is

begin

  p1 : process (clk,ctrlin)
    file my_output  : text;
    variable my_ol  : line;
    file my_backup  : text;
    variable my_bl  : line;      
    variable i : real := 0.0;
    variable temp : std_logic := '0';
    variable first : std_logic := '1';
	variable havecopy : std_logic := '0';
	variable havemerged : std_logic := '0';
	variable nrlines : integer := 0;
	VARIABLE fstatus : File_open_status;
  begin
    if havecopy='0' then
		File_open(fstatus, my_output, "simulation/output.dat", read_mode);
		File_open(fstatus, my_backup, "simulation/backup.dat", write_mode);
		while not(endfile(my_output)) loop 
		readline(my_output, my_bl);
		writeline(my_backup, my_bl);
		end loop;
		file_close(my_backup);
		file_close(my_output);
		havecopy := '1';
		File_open(fstatus, my_output, "simulation/output.dat", write_mode);
	end if;    
	if havemerged='0' and nrlines=128 then
		File_open(fstatus, my_backup, "simulation/backup.dat", read_mode);
		while not(endfile(my_backup)) loop 
		readline(my_backup, my_bl);
		writeline(my_output, my_bl);
		end loop;
		file_close(my_backup);
		file_close(my_output);
		havemerged := '1';
	end if;
  
  
    if ctrlin'event and ctrlin='0' and havemerged='0' then
		temp:='1';
		i:=3.0;
    end if;

    if clk'event and clk = '1' and temp='1' and havemerged='0' then
		if i < 1.0 then
			if first='0' then
				write(my_ol, output);
				writeline(my_output, my_ol);
				nrlines := nrlines + 1;
				i := 0.0;
				temp:='0';
			else
				first:='0';
				i := 0.0;
				temp:='0';
			end if;
		else
			i := i- 1.0;  
		end if;
    end if;

    
  end process p1;

end struct;
